<?php

 function getAccessLabels()
 {
  global $g_accesslabels;
  return array_keys($g_accesslabels);
 }

 function prefixURL($url)
 {
  if(strpos($url,"http://")===FALSE
    && strpos($url,"ftp://")===FALSE
    && strpos($url,"https://")===FALSE)
  {
   return "http://$url";
  }
  return $url;
 }

 function packCategory($category)
 {
  $cats = explode("/",$category);
  $prefix = "";
  $result = "";
  for($i=0;$i<count($cats);$i++)
  {
   $result .= $prefix.substr($cats[$i],0,3);
   $prefix = "/";
  }
  return $result;
 }

 function encryptPassword($password)
 {
  return md5($password);
 }

 function createValidationString()
 {
  return md5(" ".time());
 }

 function isAlphanumeric($password,$extra="")
 {
  $ok = "abcdefghijklmnopqrstuvwxyz";
  $ok.= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  $ok.= "0123456789";
  $ok.= $extra;

  for($i=0;$i<strlen($password);$i++)
  {
   $c = $password[$i];

   $pos = strpos($ok,$c);
   if($pos===false)
   {
    return false;
   }
  }
  return true;
 }

 function isEmail($email)
 {
  // Does not check [ip] based domain. Rarely used anyway
  $ok_local = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  $ok_local.= "abcdefghijklmnopqrstuvwxyz";
  $ok_local.= "0123456789";
  $ok_local.= "!#$%*/?|^{}`~&'+-=_.";

  $ok_domain = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  $ok_domain.= "abcdefghijklmnopqrstuvwxyz";
  $ok_domain.= "0123456789";
  $ok_domain.= "-.";

  $data = explode("@",$email);

  if(count($data)!=2)
  {
   return false;
  }

  $local = $data[0];
  $domain = $data[1];

  for($i=0;$i<strlen($local);$i++)
  {
   $c = $local[$i];
   $pos = strpos($ok_local,$c);
   if($pos===false)
   {
    return false;
   }
  }

  for($i=0;$i<strlen($domain);$i++)
  {
   $c = $domain[$i];
   $pos = strpos($ok_domain,$c);
   if($pos===false)
   {
    return false;
   }
  }

  $cnt = substr_count($domain,".");
  if($cnt==0)
  {
   return false;
  }

  $data = explode(".",$email);
  for($i=0;$i<count($data);$i++)
  {
   $dat = $data[$i];
   if(strlen($dat)==0)
   {
    return false;
   }
  }

  return true;
 }

 function getIP()
 {
  global $g_ip;

  if($g_ip!="")
   return $g_ip;

  if (getenv("HTTP_CLIENT_IP") && strcasecmp(getenv("HTTP_CLIENT_IP"), "unknown"))
   $ip = getenv("HTTP_CLIENT_IP");
  else if (getenv("HTTP_X_FORWARDED_FOR") && strcasecmp(getenv("HTTP_X_FORWARDED_FOR"), "unknown"))
   $ip = getenv("HTTP_X_FORWARDED_FOR");
  else if (getenv("REMOTE_ADDR") && strcasecmp(getenv("REMOTE_ADDR"), "unknown"))
   $ip = getenv("REMOTE_ADDR");
  else if (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], "unknown"))
   $ip = $_SERVER['REMOTE_ADDR'];
  else
   $ip = "unknown";

  $split = explode(",",$ip);
  $ip = $split[0];

  return($ip);
 }

 function formatSize($size)
 {
  if($size>1024*1024*1024)
   return round($size/(1024*1024*1024))."Gb";
  if($size>1024*1024)
   return round($size/(1024*1024))."Mb";
  if($size>1024)
   return round($size/(1024))."kb";

  return $size."b";
 }

 function stringToTime($string)
 {
  // Simple date validator, returns false if bogus date or
  // if it doesn't match any of the valid types
  // valid types:
  // YYYYMMDD HHMM
  // YYYYMMDD
  // YYYYMMDD HH:MM
  // YYYYMMDDHHMM
  // YYYYMMDDHH:MM
  // 01234567890123

  $year = 0;
  $month = 0;
  $day = 0;
  $hour = 0;
  $minute = 0;

  $pos = strpos($string,":");
  $pos2 = strpos($string," ");

  if($pos===false && $pos2 == 8 && strlen($string)==13)
  {
   $year = substr($string,0,4);
   $month = substr($string,4,2);
   $day = substr($string,6,2);
   $hour = substr($string,9,2);
   $minute = substr($string,11,2);
  }
  else if($pos===false && strlen($string)==8)
  {
   $year = substr($string,0,4);
   $month = substr($string,4,2);
   $day = substr($string,6,2);
  }
  else if($pos==11 && $pos2==8 && strlen($string)==14)
  {
   $year = substr($string,0,4);
   $month = substr($string,4,2);
   $day = substr($string,6,2);
   $hour = substr($string,9,2);
   $minute = substr($string,12,2);
  }
  else if($pos===false && $pos2===false && strlen($string)==12)
  {
   $year = substr($string,0,4);
   $month = substr($string,4,2);
   $day = substr($string,6,2);
   $hour = substr($string,8,2);
   $minute = substr($string,10,2);
  }
  else if($pos==10 && $pos2===false && strlen($string)==13)
  {
   $year = substr($string,0,4);
   $month = substr($string,4,2);
   $day = substr($string,6,2);
   $hour = substr($string,8,2);
   $minute = substr($string,11,2);
  }
  else
  {
   return false;
  }

  if(!is_numeric($year) || !is_numeric($month) || !is_numeric($day) ||
     !is_numeric($hour) || !is_numeric($minute) ||
     $hour>23 || $hour<0 || $minute>59 || $minute<0)
  {
   return false;
  }

  if(@checkdate($month,$day,$year))
  {
   return mktime($hour,$minute,0,$month,$day,$year);
  }
  return false;
 }



?>
